%ifarch %{arm} aarch64
%define build_docs 0
%else
%define build_docs 1
%endif

%define snapshot 0
%define pre rc

%define qtmajor 5
%define qtminor 15
%define qtsubminor 7

%define rel 2

%define major_private 1
%define qtversion %{qtmajor}.%{qtminor}.%{qtsubminor}

%define libqtwaylandclient %mklibname qt5waylandclient %qtmajor
%define libqtwaylandcompositor %mklibname qt5waylandcompositor %qtmajor
%define libqtwayland_d %mklibname qt5waylandclient -d

%if %snapshot
%define qttarballdir qtwayland-everywhere-src-%{qtversion}-%pre
%else
%define qttarballdir qtwayland-everywhere-opensource-src-%{qtversion}
%endif

Name:           qtwayland5
Version:        %{qtversion}
Release:        %mkrel %{rel}
Summary:        Qt%{qtmajor} Wayland platform support and QtCompositor module
Group:          Development/KDE and Qt
License:        LGPLv2 with exceptions or GPLv3 with exceptions and GFDL
URL:            https://www.qt.io
Source0:        https://download.qt.io/official_releases/qt/%{qtmajor}.%{qtminor}/%{version}/submodules/%{qttarballdir}.tar.xz
# Upstream patches
# https://community.kde.org/Qt5PatchCollection
Patch0001:      0001-Client-Announce-an-output-after-receiving-more-compl.patch
Patch0002:      0002-Fix-issue-with-repeated-window-size-changes.patch
Patch0003:      0003-Client-Connect-drags-being-accepted-to-updating-the-.patch
Patch0004:      0004-Client-Disconnect-registry-listener-on-destruction.patch
Patch0005:      0005-Client-Set-XdgShell-size-hints-before-the-first-comm.patch
Patch0006:      0006-Fix-build.patch
Patch0007:      0007-Fix-remove-listener.patch
Patch0008:      0008-Hook-up-queryKeyboardModifers.patch
Patch0009:      0009-Correctly-detect-if-image-format-is-supported-by-QIm.patch
Patch0010:      0010-Client-Don-t-always-recreate-frame-callbacks.patch
Patch0011:      0011-Client-Always-destroy-frame-callback-in-the-actual-c.patch
Patch0012:      0012-Fix-the-logic-for-decoding-modifiers-map-in-Wayland-.patch
Patch0013:      0013-Wayland-client-use-wl_keyboard-to-determine-active-s.patch
Patch0014:      0014-Client-do-not-empty-clipboard-when-a-new-popup-windo.patch
Patch0015:      0015-Set-preedit-cursor-when-cursor-equals-to-0.patch
Patch0016:      0016-Client-Implement-DataDeviceV3.patch
Patch0017:      0017-Client-Delay-deletion-of-QDrag-object-until-after-we.patch
Patch0018:      0018-Client-Avoid-processing-of-events-when-showing-windo.patch
Patch0019:      0019-Handle-registry_global-out-of-constructor.patch
Patch0020:      0020-Connect-flushRequest-after-forceRoundTrip.patch
Patch0021:      0021-Move-the-wayland-socket-polling-to-a-separate-event-.patch
Patch0022:      0022-Do-not-create-decorations-when-the-shellSurface-is-n.patch
Patch0023:      0023-Fix-crash-if-no-input-method-module-could-be-loaded.patch
Patch0024:      0024-Client-Remove-mWaitingForUpdateDelivery.patch
Patch0025:      0025-Cursor-position-0-should-still-show-the-cursor.patch
Patch0026:      0026-Update-the-preedit-styling-mapping.patch
Patch0027:      0027-client-Simplify-round-trip-behavior.patch
Patch0028:      0028-Client-Fix-opaque-region-setter.patch
Patch0029:      0029-Use-proper-dependencies-in-compile-tests.patch
Patch0030:      0030-client-update-button-state-and-etc-in-pointer_leave.patch
Patch0031:      0031-Revert-Client-Remove-mWaitingForUpdateDelivery.patch
Patch0032:      0032-Fix-race-condition-on-mWaitingForUpdateDelivery.patch
Patch0033:      0033-use-poll-2-when-reading-from-clipboard.patch
Patch0034:      0034-Reduce-memory-leakage.patch
Patch0035:      0035-Fix-build-with-libcxx-missing-array-include.patch
Patch0036:      0036-Only-close-popup-in-the-the-hierchary.patch
Patch0037:      0037-Build-fixes-for-GCC-11.patch
Patch0038:      0038-Check-pointer-for-null-before-use-in-ASSERT.patch
Patch0039:      0039-Use-wl_surface.damage_buffer-on-the-client-side.patch
Patch0040:      0040-Client-clear-focus-on-touch-cancel.patch
Patch0041:      0041-Guard-mResizeDirty-by-the-correctMutex.patch
Patch0042:      0042-client-Synthesize-enter-leave-event-for-popup-in-xdg.patch
Patch0043:      0043-Fix-compile-tests.patch
Patch0044:      0044-Use-CRLF-line-delimiter-for-text-uri-list-data.patch
Patch0045:      0045-Fix-missing-update-when-toggling-client-side-decorat.patch
Patch0046:      0046-Avoid-calling-requestUpdate-from-wrong-thread.patch
Patch0047:      0047-Client-support-high-dpi-mode-for-window-icon.patch
Patch0048:      0048-Call-finishDrag-in-QWaylandDataDevice-dragSourceCanc.patch
Patch0049:      0049-Hold-surface-read-lock-throughout-QWaylandEglWindow-.patch
Patch0050:      0050-Client-Ensure-that-wl_surface-lives-as-long-as-qtqui.patch
Patch0051:      0051-Keep-toplevel-windows-in-the-top-left-corner-of-the-.patch
Patch0052:      0052-Revert-Client-Ensure-that-wl_surface-lives-as-long-a.patch
Patch0053:      0053-Client-Add-F_SEAL_SHRINK-seal-to-shm-backing-file.patch
Patch0054:      0054-Client-Call-wl_output_release-upon-QWaylandScreen-de.patch
Patch0055:      0055-Client-Bump-wl_output-version.patch
Patch0056:      0056-Fix-frame-sync-related-to-unprotected-multithread-ac.patch


BuildRequires:  qtbase5-devel >= %version
BuildRequires:  pkgconfig(Qt5Quick) >= %version
BuildRequires:  qt5platformsupport-devel
BuildRequires:  qt5vulkansupport-devel

BuildRequires:  pkgconfig(Qt5Core)
BuildRequires:  pkgconfig(Qt5DBus)
BuildRequires:  pkgconfig(Qt5Widgets)
BuildRequires:  pkgconfig(Qt5OpenGL)

BuildRequires:  pkgconfig(xkbcommon)
BuildRequires:  pkgconfig(wayland-scanner)
BuildRequires:  pkgconfig(wayland-server)
BuildRequires:  pkgconfig(wayland-client)
BuildRequires:  pkgconfig(wayland-cursor)
BuildRequires:  pkgconfig(wayland-egl)
BuildRequires:  pkgconfig(egl)
BuildRequires:  pkgconfig(gl)
BuildRequires:  pkgconfig(glesv2)
BuildRequires:  pkgconfig(xcomposite)
BuildRequires:  pkgconfig(xrender)
BuildRequires:  pkgconfig(libudev)
BuildRequires:  pkgconfig(freetype2)
BuildRequires:  pkgconfig(fontconfig)

BuildRequires:  re2c >= 0.11.3

BuildRequires:  pkgconfig(xtst)
BuildRequires:  pkgconfig(libpci)
BuildRequires:  pkgconfig(nss)

# needed for QtServiceSupport/private/qgenericunixservices_p.h
BuildRequires:  %{_lib}qt5servicesupport-static-devel
# needed for QtFontDatabaseSupport/private/qgenericunixfontdatabase_p.h
BuildRequires:  %{_lib}qt5fontdatabasesupport-static-devel
BuildRequires:  %{_lib}qt5themesupport-static-devel
BuildRequires:  %{_lib}qt5eventdispatchersupport-static-devel
BuildRequires:  %{_lib}qt5eglsupport-static-devel
BuildRequires:  %{_lib}qt5glxsupport-static-devel
BuildRequires:  %{_lib}qt5xkbcommonsupport-static-devel
BuildRequires:  %{_lib}qt5accessibilitysupport-static-devel
BuildRequires:  %{_lib}qt5linuxaccessibilitysupport-static-devel

#Branch Patchs

#Trunk Patchs

#Patch from Mageia

%description
Qt%{qtmajor} Wayland platform support and QtCompositor module.

%files
%{_qt5_bindir}/qtwaylandscanner
%{_qt5_qml}/QtWayland/
%{_qt5_plugindir}/platforms/*.so
%{_qt5_plugindir}/wayland-decoration-client/
%{_qt5_plugindir}/wayland-graphics-integration-client/
%{_qt5_plugindir}/wayland-graphics-integration-server/
%{_qt5_plugindir}/wayland-shell-integration/

#------------------------------------------------------------------------------

%if %{build_docs}
%package        doc
Summary:        QtWayland%{qtmajor} APIs and tools docs
Group:          Documentation
BuildArch:      noarch
BuildRequires:  qttools5
# This one is required to build QCH-format documentation
# for APIs and tools in this package set
BuildRequires:  qttools5-assistant
Recommends:     qttools5-assistant

%description doc
Documentation for APIs and tools in QtWayland%{qtmajor} package for
use with Qt Assistant.

%files doc
%{_qt5_docdir}/qtwayland*.qch
%{_qt5_docdir}/qtwayland*/
%endif

#------------------------------------------------------------------------------

%package -n     %{libqtwaylandclient}
Summary:        Qt%{qtmajor} WaylandClient Component Library
Group:          System/Libraries

%description -n %{libqtwaylandclient}
Qt%{qtmajor} WaylandClient Component Library.

%files -n %{libqtwaylandclient}
%{_qt5_libdir}/libQt5WaylandClient.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtwaylandcompositor}
Summary:        Qt%{qtmajor} WaylandCompositor Component Library
Group:          System/Libraries

%description -n %{libqtwaylandcompositor}
Qt%{qtmajor} WaylandCompositor Component Library.

%files -n %{libqtwaylandcompositor}
%{_qt5_libdir}/libQt5WaylandCompositor.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtwayland_d}
Summary:        Devel files needed to build apps based on QtWayland
Group:          Development/KDE and Qt
Requires:       %{libqtwaylandclient} = %version
Requires:       %{libqtwaylandcompositor} = %version
Requires:       %{_lib}qt5linuxaccessibilitysupport-static-devel
Requires:       qtwayland5 >= %version
Provides:       libqtwayland5-devel = %version
Provides:       libqt5wayland-devel = %version
Provides:       qtwayland5-devel = %version
Provides:       qt5wayland-devel = %version

Provides:       libqtwayland-private-devel = %version
Provides:       libqtwayland5-private-devel = %version
Provides:       libqt5wayland-private-devel = %version
Provides:       qtwayland-private-devel = %version
Provides:       qt5wayland-private-devel = %version

%description -n %{libqtwayland_d}
Devel files needed to build apps based on Qt Wayland.

%files -n %{libqtwayland_d}
%{_qt5_libdir}/libQt5WaylandClient.so
%{_qt5_libdir}/libQt5WaylandCompositor.so
%{_qt5_libdir}/libQt5WaylandClient.prl
%{_qt5_libdir}/libQt5WaylandCompositor.prl
%{_qt5_libdir}/pkgconfig/Qt5WaylandClient.pc
%{_qt5_libdir}/pkgconfig/Qt5WaylandCompositor.pc
%{_qt5_includedir}/QtWaylandClient/
%{_qt5_includedir}/QtWaylandCompositor/
%{_qt5_archdatadir}/mkspecs/modules/qt_lib_waylandclient.pri
%{_qt5_archdatadir}/mkspecs/modules/qt_lib_waylandcompositor.pri
%{_qt5_libdir}/cmake/Qt5WaylandClient/
%{_qt5_libdir}/cmake/Qt5WaylandCompositor/
%{_qt5_libdir}/cmake/Qt5Gui/*
%{_qt5_archdatadir}/mkspecs/modules/qt_lib_waylandclient_private.pri
%{_qt5_archdatadir}/mkspecs/modules/qt_lib_waylandcompositor_private.pri
%{_qt5_examplesdir}/wayland/

#------------------------------------------------------------------------------

%prep
%setup -q -n qtwayland-everywhere-src-%{qtversion}
%autopatch -p1

%build
%qmake_qt5

%make_build

%if %{build_docs}
%__make docs
%endif

%install
%make_install INSTALL_ROOT=%{buildroot}

%if %{build_docs}
%make_install install_docs INSTALL_ROOT=%{buildroot}
%endif

# .la and .a files, die, die, die.
find %{buildroot} -name '*.la' -delete
find %{buildroot} -name '*.a' -delete

# Temporary workaround until an upstream fix
sed -i 's| Qt5LinuxAccessibilitySupport||' %{buildroot}%{_qt5_libdir}/pkgconfig/Qt5WaylandClient.pc
sed -i 's|"Qt5::LinuxAccessibilitySupport;|"|' %{buildroot}%{_qt5_libdir}/cmake/Qt5WaylandClient/Qt5WaylandClientConfig.cmake
sed -i 's|"LinuxAccessibilitySupport;|"|' %{buildroot}%{_qt5_libdir}/cmake/Qt5WaylandClient/Qt5WaylandClientConfig.cmake


%changelog
* Wed Dec 14 2022 daviddavid <daviddavid> 5.15.7-2.mga9
+ Revision: 1922136
- devel pkg requires main pkg qtwayland5

* Mon Dec 12 2022 neoclust <neoclust> 5.15.7-1.mga9
+ Revision: 1920820
- New version 5.15.7

* Sun Sep 11 2022 neoclust <neoclust> 5.15.6-1.mga9
+ Revision: 1886984
- New version 5.15.6

* Sat Aug 27 2022 neoclust <neoclust> 5.15.5-1.mga9
+ Revision: 1881248
- New version 5.15.5

* Mon Apr 04 2022 umeabot <umeabot> 5.15.2-3.mga9
+ Revision: 1843472
- Mageia 9 Mass Rebuild

* Wed Jan 06 2021 daviddavid <daviddavid> 5.15.2-2.mga8
+ Revision: 1669221
- add upstream patch to avoid accessing dangling pointers in destroy_func() from Scanner

* Fri Dec 04 2020 daviddavid <daviddavid> 5.15.2-1.mga8
+ Revision: 1652479
- New version 5.15.2

* Tue Oct 20 2020 daviddavid <daviddavid> 5.15.1-2.mga8
+ Revision: 1637280
- enable vulkan support

* Sat Sep 12 2020 daviddavid <daviddavid> 5.15.1-1.mga8
+ Revision: 1624926
- New version 5.15.1

* Wed Jun 03 2020 daviddavid <daviddavid> 5.15.0-1.mga8
+ Revision: 1589839
- New version 5.15.0

* Thu Feb 20 2020 umeabot <umeabot> 5.14.1-2.mga8
+ Revision: 1545568
- Mageia 8 Mass Rebuild

* Tue Jan 28 2020 daviddavid <daviddavid> 5.14.1-1.mga8
+ Revision: 1484414
- New version 5.14.1

* Sun Sep 08 2019 neoclust <neoclust> 5.13.1-1.mga8
+ Revision: 1438507
- New version 5.13.1

* Sun Jul 14 2019 neoclust <neoclust> 5.13.0-4.mga8
+ Revision: 1421134
- Rebuild for new mkspecs macros

* Sun Jul 07 2019 daviddavid <daviddavid> 5.13.0-3.mga8
+ Revision: 1419247
- fix a typo in workaround

* Sun Jul 07 2019 daviddavid <daviddavid> 5.13.0-2.mga8
+ Revision: 1419233
- temporary workaround the LinuxAccessibilitySupport static dependencies issue

* Thu Jul 04 2019 daviddavid <daviddavid> 5.13.0-1.mga8
+ Revision: 1418535
- New version 5.13.0

* Mon Apr 01 2019 umeabot <umeabot> 5.12.2-2.mga7
+ Revision: 1384576
- Qt5 Rebuild

* Mon Mar 18 2019 neoclust <neoclust> 5.12.2-1.mga7
+ Revision: 1378553
- New version 5.12.2

* Fri Feb 01 2019 neoclust <neoclust> 5.12.1-1.mga7
+ Revision: 1362298
- New version 5.12.1

* Sun Dec 09 2018 neoclust <neoclust> 5.12.0-1.mga7
+ Revision: 1339153
- New version 5.12.0

* Tue Oct 09 2018 neoclust <neoclust> 5.11.2-1.mga7
+ Revision: 1319042
- New version 5.11.2

* Sun Sep 23 2018 umeabot <umeabot> 5.11.1-2.mga7
+ Revision: 1300733
- Mageia 7 Mass Rebuild

* Sun Jul 29 2018 neoclust <neoclust> 5.11.1-1.mga7
+ Revision: 1245828
- New version 5.11.1

* Fri May 25 2018 neoclust <neoclust> 5.11.0-1.mga7
+ Revision: 1232127
- New version 5.11.0

* Mon Apr 09 2018 neoclust <neoclust> 5.10.1-1.mga7
+ Revision: 1216522
- New version 5.10.1

* Wed Feb 28 2018 neoclust <neoclust> 5.9.4-1.mga7
+ Revision: 1205689
- New version 5.9.4

* Mon Dec 18 2017 neoclust <neoclust> 5.9.3-1.mga7
+ Revision: 1183200
- New version 5.9.3

* Fri Aug 04 2017 daviddavid <daviddavid> 5.9.1-2.mga7
+ Revision: 1134850
- build missing docs part (mga#9812)
- add qtwayland5-doc subpackage

* Fri Aug 04 2017 neoclust <neoclust> 5.9.1-1.mga7
+ Revision: 1134845
- New version 5.9.1

* Thu Nov 03 2016 neoclust <neoclust> 5.6.2-1.mga6
+ Revision: 1064833
- New version 5.6.2

* Sun Jul 03 2016 neoclust <neoclust> 5.6.1-2.mga6
+ Revision: 1038386
- Update to version 5.6.1-1
- New version

* Wed May 11 2016 akien <akien> 5.6.0-2.mga6
+ Revision: 1013634
- Fix libname s/libgqtwaylandclient5/libqt5waylandclient5/

* Thu Mar 17 2016 neoclust <neoclust> 5.6.0-1.mga6
+ Revision: 992521
+ rebuild (emptylog)

* Wed Mar 09 2016 neoclust <neoclust> 5.6.0-0.rc.2.mga6
+ Revision: 987769
- Rebuild Qt5 Stack to fix plasma crashes

* Sun Feb 28 2016 neoclust <neoclust> 5.6.0-0.rc.1.mga6
+ Revision: 980621
+ rebuild (emptylog)

* Tue Feb 16 2016 umeabot <umeabot> 5.6.0-0.beta.5.mga6
+ Revision: 962561
- Mageia 6 Mass Rebuild

* Sun Dec 27 2015 neoclust <neoclust> 5.6.0-0.beta.4.mga6
+ Revision: 915936
- Rebuild against new cmake to have cmake() provides

* Sun Dec 27 2015 neoclust <neoclust> 5.6.0-0.beta.3.mga6
+ Revision: 915809
- Rebuild against new cmake to have cmake() provides

* Mon Dec 21 2015 neoclust <neoclust> 5.6.0-0.beta.2.mga6
+ Revision: 912792
- Remove private devel packages
- New version 5.6.0 Beta
- New version 5.6.0 Beta

* Tue Nov 10 2015 neoclust <neoclust> 5.5.1-2.mga6
+ Revision: 900342
- Rebuild against fixed qtbase5

* Fri Oct 23 2015 neoclust <neoclust> 5.5.1-1.mga6
+ Revision: 894506
- New version

* Sun Jul 12 2015 filipesaraiva <filipesaraiva> 5.5.0-1.mga6
+ Revision: 853390
- Update to Qt 5.5.0 version;
- Fix URL to new address qt.io;

* Wed Jun 24 2015 neoclust <neoclust> 5.5.0-0.r.1.mga6
+ Revision: 842042
- New version 5.5 rc

* Mon Dec 22 2014 neoclust <neoclust> 5.4.0-1.mga5
+ Revision: 804771
- New version 5.4.0
+ umeabot <umeabot>
- Second Mageia 5 Mass Rebuild
- Mageia 5 Mass Rebuild

* Wed Feb 05 2014 neoclust <neoclust> 5.1.0-0.5.20131120git8cd1a77.1.mga5
+ Revision: 583556
- imported package qtwayland5


* Sat Nov 23 2013 Lubomir Rintel <lkundrak@v3.sk> - 5.1.0-0.5.20131120git8cd1a77
- Rebuild with EGL backend

* Fri Nov 22 2013 Lubomir Rintel <lkundrak@v3.sk> - 5.1.0-0.4.20131120git8cd1a77
- Rebase to a later snapshot, drop 5.2 ABI patch
- Enable nogl backend

* Sun Nov 10 2013 Rex Dieter <rdieter@fedoraproject.org> 5.1.0-0.4.20130826git3b0b90b
- rebuild (arm/qreal)

* Thu Oct 24 2013 Lubomir Rintel <lkundrak@v3.sk> - 5.1.0-0.3.20130826git3b0b90b
- Bulk sad and useless attempt at consistent SPEC file formatting

* Sun Oct 06 2013 Lubomir Rintel <lkundrak@v3.sk> - 5.1.0-0.2.20130826git3b0b90b
- Bump platform plugin ABI to 5.2 for Qt 5.2 aplha

* Wed Sep 11 2013 Lubomir Rintel <lkundrak@v3.sk> - 5.1.0-0.1.20130826git3b0b90b
- Initial packaging
- Adjustments from review (Rex Dieter, #1008529)
